# @author Donnie Cameron (macnod)
# @url    https://github.com/macnod/DcServer
# @readme http://donnieknows.com/blog/perl-sockets-swimming-thread-pool

package SocketsSwimmingThreadPoolClient;

use IO::Socket;
use Carp;
use strict;
use warnings;

sub new
{
  # Params: host, port
  my ($proto, %param)= @_;
  my $class= ref($proto) || $proto;
  bless +{%param} => $class;
}

sub stop_server
{
  shift->query('$self->stop')
}

sub query
{
  my ($self, $query)= @_;
  my $socket= new IO::Socket::INET(PeerAddr => $self->{host} || 'localhost',
                                   PeerPort => $self->{port} || 8191,
                                   Proto => 'tcp');
  croak "$!. Is the server running?\n" unless $socket;
  print $socket $query . "\n.\n";
  my $buffer = '';
  my $reply = '';
  while($buffer = <$socket>)
  {
    $reply.= $buffer;
    last if $reply =~ s/\n\.\n$//;
  }
  $socket->shutdown(2);
  return $reply;
}

1;
